unit IntDlg;
// Simple Integer type property editor Dialog Class
// By "ComIdiot" Andyca Chiou [l]
// E-Mail:k51vum@ms2.hinet.net
// 8/30/96

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, DsgnIntf, Spin, Buttons;

type
  TIntEditDlg = class(TForm)
    NumEdit: TSpinEdit;
    InputLabel: TLabel;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TIntProperty = class(TIntegerProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

  TIntEditor = class(TDefaultEditor)
  protected
    procedure EditProperty(propertyEditor: TPropertyEditor;
                var Continue, FreeEditor: boolean); override;
  public
    procedure ExecuteVerb(index: integer);override;
    function GetVerb(Index: integer): string; override;
    function GetVerbCount: integer; override;
  end;

//var
//  IntEditDlg: TIntEditDlg;

implementation

{$R *.DFM}

procedure TIntProperty.Edit;
var
  i : integer;
  IntEditor : TIntEditDlg;
begin
  i := integer(GetOrdValue);
  IntEditor := TIntEditDlg.Create(Application);
  IntEditor.InputLabel.Caption := 'Input ' + GetName + ':';
  IntEditor.NumEdit.Text := IntToStr(i);
  try
    if IntEditor.ShowModal = mrOK then
      SetOrdValue(StrToInt(IntEditor.NumEdit.Text));
  finally
    IntEditor.Free;
  end;
end;

function TIntProperty.GetAttributes: TPropertyAttributes;
begin
  Result := inherited GetAttributes + [paDialog];
end;

procedure TIntEditor.EditProperty(propertyEditor: TPropertyEditor;
                var Continue, FreeEditor: boolean);
var
  s : string;
begin
  s := PropertyEditor.GetName;
  if (CompareText(s, 'Value') = 0) then
  begin
    PropertyEditor.Edit;
    Continue := False;
  end;
end;

procedure TIntEditor.ExecuteVerb(Index: integer);
begin
  case Index of
    0 : Edit;
    1 : begin
      MessageBeep(MB_OK);
      Application.MessageBox('Simple VCL property Editor, by Andyca Chiou',
      'About SimpleVCL', MB_OK or MB_ICONINFORMATION);
    end;
  end;
end;

function TIntEditor.GetVerb(Index: integer): string;
begin
  case Index of
    0 : Result := 'E&dit Value';
    1 : Result := 'Abo&ut';
  else
    Result := '';
  end;
end;

function TIntEditor.GetVerbCount: integer;
begin
  Result := 2;
end;

end.
